
# biolinux bash shell script with variables and function; to be run in same directory as BLAT executable.
# COI contig coverage version 3; high BLAT match stringency minIdentity 97%; all reads
# Maps all reads against each selected contig per sample in fasta file created by THING.sh shell script


coiconcov(){
echo $NAME
# FORMAT APPROPRIATE DIRECTORY PATHS AND READ FILE LABELS
gunzip -c /home/ahugall/blatSuite/TREADS/${NAME}"_T820_R1.fastq.gz" > sample.fastq
gunzip -c /home/ahugall/blatSuite/TREADS/${NAME}"_T820_R2.fastq.gz" >> sample.fastq
perl -e '$i=0;while(<>){if(/^\@/&&$i==0){s/^\@/\>/;print;}elsif($i==1){print;$i=-3}$i++;}' sample.fastq > sample.fasta
grep -A 1 $NAME"_" ${RUN}"_COI_contigs.fasta" | sed 's/-//g' > coicont.fasta
./blat sample.fasta coicont.fasta COI_BLAT_cov.psl -t=dna -q=dna -minIdentity=97 -out=psl
tail -n +6 COI_BLAT_cov.psl > BLATcoiout.psl
cut -f 10 BLATcoiout.psl | uniq -c | sort -nr >> ${RUN}"_COI_contig_hits.txt"
echo
}


# COI CONTIG FASTA FILE PREFIX
RUN=OPH07d

# INSERT LIST OF SAMPLE NAMES TO BE PROCESSED (as shell variable 'NAME', then invoke shell function)
NAME=Ophiocoma_cynthiae_emilie3
coiconcov
NAME=Ophiocoma_krohi_emilie2
coiconcov
NAME=Ophiocoma_sp_emilie7
coiconcov


# ADDS COVERAGE TO SAMPLE LABELS IN FASTA FILE
tr '\n' ' ' < ${RUN}"_COI_contigs.fasta" | tr '>' '\n' | sed 1d | sort > coicontS.txt
sort -k2,2 ${RUN}"_COI_contig_hits.txt" > coihitS.txt.txt
join -1 2 -2 1 coihitS.txt.txt coicontS.txt | awk '{print ">"$1"+"$2, $3}' | sed 's/ /\n/' > ${RUN}"_COI_contigs_cov.fasta"

